#Python-3.4.1 text processing library
#
#cut_from_begin_to_mask.py
#
#GPL2 Orlov Alexander Sergeevich 2014
#
#Contacts
#www.suny-o.narod.ru
#www.vk.com\aorlov1979
#suny-o@yandex.ru
#aorlv@yandex.ru
#
#---------------------------------------------------------------------------------------------
#This program is free software; you can redistribute it and/or modify it in accordance with
#GNU General Public License, as published
#By the Free software Foundation; either version 2, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT ANY warranty; without even the
#implied warranties of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE. For more information see the General Public
#The GNU license.
#
#------------------------------------------------------------------------------
#Description of the script
#The script truncates the string from the beginning of the string to the mask
#
#The script works from the command line
#Command line format:
#script mask in_file out_file on_off flag
#script /? - display help
#where
#script=cut_from_begin_to_mask.py
#mask=mask search words in the string in the format python
#in_file=the name of the input file
#out_file=output file name
#on_off=on-insert mask in a row off-not insert mask in a row
#flag=option (s) which will be processed the file
#flag=0 case sensitive
#flag=i to ignore case
#Note:
#If the file name contains spaces or mask contain special characters, you need to put them in double quotes ""

import sys
try:
 if sys.argv[1]=='/?':
  print('Description of the script')
  print('The script truncates the string from the beginning of the string to the mask')
  print(' ')
  print('The script works from the command line')
  print('Command line format:')
  print('script mask in_file out_file on_off flag')
  print('script /? - display help')
  print('where')
  print('script=cut_from_mask_to_end.py')
  print('mask=mask search words in the string in the format python')
  print('in_file=the name of the input file')
  print('out_file=output file name')
  print('on_off=on-insert mask in a row off-not insert mask in a row')
  print('flag=option (s) which will be processed the file')
  print('flag=0 case sensitive')
  print('flag=i to ignore case')
  print('Note:')
  print('If the file name contains spaces or masks contain special characters, you need to put them in double quotes ""')
  exit()
 else:
  print('format:script mask in_file out_file on_off flag')
  print('format:script /? - display help')
  print('Note:')
  print('If the file name contains spaces or masks contain special characters, you need to put them in double quotes ""')
  print('script=',sys.argv[0])
  print('mask=',sys.argv[1])
  print('in_file=',sys.argv[2])
  print('out_file=',sys.argv[3])
  print('on_off=',sys.argv[4])
  print('flag=',sys.argv[5])
except IndexError:
 print('Error! - command line parameters are not set correctly')
 print('More command-line options, see the script')
import re
#The input file
fr = open(sys.argv[2], 'r')
#Output file
fw = open(sys.argv[3], 'w')
for line in fr:
 s=line
 #Mask for search
 a=sys.argv[1]
 if sys.argv[5]=='0':
   s1=re.search(a, s, flags=0)
   if sys.argv[4]=='on':
       s3=s[:s1.end()]
   if sys.argv[4]=='off':     
       s3=s[:s1.start()]
 if sys.argv[5]=='i':
   s1=re.search(a, s, flags=re.IGNORECASE)
   if sys.argv[4]=='on':
       s3=s[:s1.end()]
   if sys.argv[4]=='off':     
       s3=s[:s1.start()]
 s13=re.search('\n', s, flags=re.IGNORECASE)
 if s13 and not s3=='':
 #print('Found line wrapping')
  s3=s3+'\n'       
 fw.write(s3) 
fr.close()
fw.close()
print('File processing completed')
