#Python-3.4.1 text processing library
#
#find_and_replace.py
#
#GPL2 Orlov Alexander Sergeevich 2014
#
#Contacts
#www.suny-o.narod.ru
#www.vk.com\aorlov1979
#suny-o@yandex.ru
#aorlv@yandex.ru
#
#---------------------------------------------------------------------------------------------
#This program is free software; you can redistribute it and/or modify it in accordance with
#GNU General Public License, as published
#By the Free software Foundation; either version 2, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT ANY warranty; without even the
#implied warranties of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE. For more information see the General Public
#The GNU license.
#
#------------------------------------------------------------------------------
#Description of the script
#The script finds in a string the words on the mask and replaces a given word
#
#The script works from the command line
#Command line format:
#script mask replacement in_file out_file number_of_replacement flag
#script /? - display help
#where
#script=find_and_replace.py
#mask=mask search words in the string in the format python
#replacement=the word which will be replaced all found by mask match
#in_file=the name of the input file
#out_file=the name of the output file
#number_of_replacement=the maximum number of substitutions in the string 0=replace all
#flag=option (s) which will be processed the file
#flag=0 consider the case
#flag=i ignore case
#Note:
#If the file name contains spaces or mask or replacement contain special characters, you need to put them in double quotes ""

import sys
try:
 if sys.argv[1]=='/?':
  print('Description of the script')
  print('The script finds in a string the words on the mask and replaces a given word')
  print(' ')
  print('The script works from the command line')
  print('Command line format:')
  print('script mask replacement in_file out_file number_of_replacement flag')
  print('script /? - display help')
  print('where')
  print('script=find_and_replace.py')
  print('mask=mask search words in the string in the format python')
  print('replacement=the word which will be replaced all found by mask match')
  print('in_file=the name of the input file')
  print('out_file=the name of the output file')
  print('number_of_replacement=the maximum number of substitutions in the string 0=replace all')
  print('flag=option (s) which will be processed the file')
  print('flag=0 consider the case')
  print('flag=i ignore case')
  print('Note:')
  print('If the file name contains spaces or mask or replacement contain special characters, you need to put them in double quotes ""')
  exit()
 else:
  print('format:script mask replacement in_file out_file number_of_replacement flag')
  print('format:script /? - display help')
  print('Note:')
  print('If the file name contains spaces or mask or replacement contain special characters, you need to put them in double quotes ""')
  print('script=',sys.argv[0])
  print('mask=',sys.argv[1])
  print('replacement=',sys.argv[2])
  print('in_file=',sys.argv[3])
  print('out_file=',sys.argv[4])
  print('number of replacement=',sys.argv[5])
  print('flag=',sys.argv[6])
except IndexError:
 print('Error! - command line parameters are not set correctly')
 print('More command-line options, see the script')
import re
#The input file
fr = open(sys.argv[3], 'r')
#Output file
fw = open(sys.argv[4], 'w')
for line in fr:
 s=line
 #Mask search
 a=sys.argv[1]
 #How to replace the found word
 b=sys.argv[2]
 if sys.argv[6]=='0':
   s2=re.sub(a,b,s, count=int(sys.argv[5]), flags=0)
 if sys.argv[6]=='i':
   s2=re.sub(a,b,s, count=int(sys.argv[5]), flags=re.IGNORECASE)
 fw.write(s2) 
fr.close()
fw.close()
print('File processing completed')
