#Python-3.4.1 text processing library
#
#find_and_replace_by_list.py
#
#GPL2 Orlov Alexander Sergeevich 2014
#
#Contacts
#www.suny-o.narod.ru
#www.vk.com\aorlov1979
#suny-o@yandex.ru
#aorlv@yandex.ru
#
#---------------------------------------------------------------------------------------------
#This program is free software; you can redistribute it and/or modify it in accordance with
#GNU General Public License, as published
#By the Free software Foundation; either version 2, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT ANY warranty; without even the
#implied warranties of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE. For more information see the General Public
#The GNU license.
#
#------------------------------------------------------------------------------
#Description of the script
#The script finds in a string of words on the mask and replaces a given word n times
#Mask, replacing the word and chillen is taken from a file
#File format - a list of strings in the format:mask key replacement key replacement_number
#replacement_number=maximum number of substitutes one mask in row 0=replace all
#Search and replace works with the whole list
#If one string has a Mask1 and Mask2 then will be Replacement1 and Replacement2
#In accordance with the list
#
#The script works from the command line
#Command line format:
#script list_file in_file out_file key flag
#script /? - display help
#where
#script=find_and_replace_by_list.py
#list_file=name of file containing a list of masks, substitutions and the number of substitutions (masks in the python format)
#in_file=the name of the input file
#out_file=the name of the output file
#key=word or symbol separates the elements of the list
#flag=option (s) which will be processed the file
#flag=0 consider the case
#флаг=i ignore case
#Note:
#If the file name contains spaces or mask or replacement contain special characters, you need to put them in double quotes ""

import sys
try:
 if sys.argv[1]=='/?':
  print('Description of the script')
  print('The script finds in a string of words on the mask and replaces a given word n times')
  print('Mask, replacing the word and chillen is taken from a file')
  print('File format - a list of strings in the format:mask key replacement key replacement_number')
  print('replacement_number=maximum number of substitutes one mask in row 0=replace all')  
  print('Search and replace works with the whole list')
  print('If one string has a Mask1 and Mask2 then will be Replacement1 and Replacement2')
  print('In accordance with the list')
  print(' ')
  print('The script works from the command line')
  print('Command line format:')
  print('script list_file in_file out_file key flag')
  print('script /? - display help')
  print('where')
  print('script=find_and_replace_by_list.py')
  print('list_file=name of file containing a list of masks, substitutions and the number of substitutions (masks in the python format)')
  print('in_file=the name of the input file')
  print('out_file=the name of the output file')
  print('key=word or symbol separates the elements of the list')  
  print('flag=option (s) which will be processed the file')
  print('flag=0 consider the case')
  print('flag=i ignore case')
  print('Note:')
  print('If the file name contains spaces or mask or replacement contain special characters, you need to put them in double quotes ""')
  exit()
 else:
  print('format:script list_file in_file out_file key flag')
  print('format:script /? - display help')
  print('Note:')
  print('If the file name contains spaces or mask or replacement contain special characters, you need to put them in double quotes ""')
  print('script=',sys.argv[0])
  print('list_file=',sys.argv[1])
  print('in_file=',sys.argv[2])
  print('out_file=',sys.argv[3])
  print('key=',sys.argv[4])
  print('flag=',sys.argv[5])
except IndexError:
 print('Error! - command line parameters are not set correctly')
 print('More command-line options, see the script')
import re
#The masks and replacement list file
flist = open(sys.argv[1], 'r')
#The input file
fr = open(sys.argv[2], 'r')
#Output file
fw = open(sys.argv[3], 'w')
find=[]
replace=[]
n_times=[]
for plist in flist:
 s012=plist.split(sep=sys.argv[4], maxsplit=-1)
 find=find+[s012[0]]
 replace=replace+[s012[1]]
 n_times=n_times+[s012[2]]
print('Mask for search:',find)
print('Mask to replace is not processed:',replace)
print('The corresponding number of substitutions is not processed:',n_times)
#Remove hyphens from replacement
n=-1
for s1 in replace:
 n=n+1   
 s1=re.sub('\n','',s1, count=0, flags=re.IGNORECASE)
 replace[n]=s1
print('Mask for replacing processed:',replace)
#To remove the hyphens from the number of substitutions
n=-1
for s1 in n_times:
 n=n+1   
 s1=re.sub('\n','',s1, count=0, flags=re.IGNORECASE)
 n_times[n]=s1
print('The appropriate number of changes processed:',n_times)
#Search and replace in current row
for line in fr:
 s=line
 #Search through the list of masks
 n=-1
 #s2=''
 for s1 in find:
  n=n+1
  if n>0:
   s=s2   
  #Mask search   
  a=find[n]
  #How to replace the found word
  b=replace[n]
  #The number of substitutions
  c=int(n_times[n])
  if sys.argv[5]=='0':
    s2=re.sub(a,b,s, count=c, flags=0)
  if sys.argv[5]=='i':
    s2=re.sub(a,b,s, count=c, flags=re.IGNORECASE)
  #print(a,b,s,s2)  
 fw.write(s2) 
flist.close()
fr.close()
fw.close()
print('File processing completed')
